% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


function videoInfo = funcGetAVisualFeat(videoMpgFile) %#codegen
% This function to extract the Keyframe and ColorHistogram
% mpgFiles  = dir([direc '\*.mpg']);

bCheckBoundary          = 1;
chGridSize              = 4;
simThres                = 0.9;
maxDurationInOneShot    = 30;


for mf=1:1   
    % create the video object
    % ---------------------------------------------------------------------
    videoObj = []; % mmreader(videoMpgFile);

    % get number of frames
    % ---------------------------------------------------------------------
%     numFrames       = get(videoObj, 'numberOfFrames');
%     frameRate       = get(videoObj, 'FrameRate');
%     rows            = get(videoObj, 'Height');
%     cols            = get(videoObj, 'Width');
%     duration        = get(videoObj, 'Duration');
%     maxFrameInShot  = ceil(maxDurationInOneShot*frameRate);
    numBins         = chGridSize*chGridSize*chGridSize;
%     frameGap        = max(ceil(frameRate/2), 5); % capture at 2 frames per second    
% 
%     feaSpace        = zeros(maxFrameInShot, numBins);
%     fridx           = zeros(maxFrameInShot, 1);
% 
%     % extract the boundary box
%     % ---------------------------------------------------------------------  
%     if bCheckBoundary == 1
%         [row_start, row_end, col_start, col_end] = GetBoxBoundary(videoObj, numFrames, rows, cols);
%     else
%         row_start = 1;
%         col_start = 1;
%         row_end = rows;
%         col_end = cols;
%     end;
       
    % extract all frames
    % ---------------------------------------------------------------------
%     numkeyframes = 1;
%     idx = 1;
%     frameidx = 1:frameGap:numFrames-1;
%     if (frameidx(end) ~= numFrames-1)
%         frameidx = [frameidx numFrames-1];
%     end;
    
%     fid = fopen ([videodirec '\' fname '.bdy'], 'w');    
%     shot_start = 1;  

    videoInfoAll = textread('../video_db/video_info.txt', '%s', 'delimiter', '\n');
    numkeyframes = numel(videoInfoAll);
    if length(videoInfoAll{end})==0
        numkeyframes = numkeyframes - 1;
    end;
    keyframes = zeros(numkeyframes,1);
    frametime = zeros(numkeyframes,1);
    visualFeat= zeros(numkeyframes,numBins);
    
    for frameidx = 1:numkeyframes
        thisFrameInfo = regexp(videoInfoAll{frameidx}, ',', 'split');
        keyframes(frameidx) = str2num(thisFrameInfo{1});
        frametime(frameidx) = str2num(thisFrameInfo{2});
        
        curFrame = readAFrame(videoObj, keyframes(frameidx));
        visualFeat(frameidx,:) = getHist(curFrame, chGridSize);
    end;

    videoInfo.visualFeat = visualFeat;
    videoInfo.keyframes  = keyframes;
    videoInfo.frameTime  = frametime;
%     fclose(fid);
end;
% fclose(ifid);  %image files list
% 
% t = toc;
% fid = fopen([direc 'result.log'], 'w');
% fprintf(fid, 'Frame Converstion Time = %f\n', t);
% fclose(fid);
end


function data = readAFrame(videoObj, frmIdx)
    data = imread(sprintf('../video_db/imag_%d.jpg',frmIdx));
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% refine the frame by Richard
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function del = whetherdel(curframe)
        % delete according to the ratio of black pixels to white pixels
        del       = false;
        ratio_th  = 0.6; %the ratio, we care more informative keyframe, we can set this even 0.5.
        lvalue_th = 15;  %the threshold
        hvalue_th = 240;
        
        if length(size(curframe)) == 3
            curframe = mean(curframe,3);
        end
        
        lratio = length(find(curframe < lvalue_th)) / prod(size(curframe));
        hratio = length(find(curframe > hvalue_th)) / prod(size(curframe));
        if lratio > ratio_th || hratio > ratio_th 
            del = true;
        end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exclude the black box by simple  operation by Richard
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [csind,ceind,rsind,reind,hqflg] = removeBlkbox(img)
    diff_th   = 10;
    hqflg     = true;   %high quality flag

    if length(size(img)) == 3
          img = mean(img,3);
    end
    
    % cut black column
    cdif = max(img,[],1) - min(img,[],1);
    csind = min(find(cdif > diff_th)); %column start index
    ceind = max(find(cdif > diff_th)); %column end index
    
    % cut black row
    rdif = max(img,[],2) - min(img,[],2);
    rsind = min(find(rdif > diff_th)); %row start index
    reind = max(find(rdif > diff_th)); %row end index
    
    if isempty(reind) || isempty(ceind) || isempty(csind) || isempty(rsind)
       hqflg = false;
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get the box
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [row_start, row_end, col_start, col_end] = GetBoxBoundary(videoObj, numFrames, rows, cols)

k = 30;
thres = 70;
frList1 = randperm(numFrames);
frList1 = frList1(1:min(numFrames, k));
frList2 = randperm(numFrames);
frList2 = frList2(1:min(numFrames, k));
avgDiff = zeros(rows, cols);

for i=1:k
    rawframe1 = readAFrame(videoObj, frList1(i)); 
    if size(rawframe1,2) > 2
        rawframe1 = double(rgb2gray(rawframe1));
    end;
    
    rawframe2 = readAFrame(videoObj, frList2(i));    
    if size(rawframe2,2) > 2
        rawframe2 = double(rgb2gray(rawframe2));
    end;
    
    diff = abs(rawframe1-rawframe2);
    if max(max(diff)) < 20
        continue;
    end;
    avgDiff = max(avgDiff,diff);
end

% vertical boundary
positions = find(max(avgDiff, [], 2) < thres);
if ~isempty(positions)
    if ~isempty(find(positions<rows/2))
        row_start = max(positions(positions<rows/2));
    else
        row_start = 1;
    end;
    if ~isempty(find(positions>rows/2))
        row_end   = min(positions(positions>rows/2));
    else
        row_end = rows;
    end;
end;

if isempty(positions) || row_end - row_start < rows*0.5
    row_start = 1;
    row_end = rows;
end;

% horizontal boundary
positions = find(max(avgDiff) < thres);
if ~isempty(positions)
    if ~isempty(find(positions<cols/2))
        col_start = max(positions(positions<cols/2));
    else
        col_start = 1;
    end;
    if ~isempty(find(positions>cols/2))
        col_end   = max(positions(positions>cols/2));
    else
        col_end = cols;
    end;
end;
if isempty(positions) || col_end - col_start < cols*0.6
    col_start = 1;
    col_end  = cols;        
end;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get the valid movie region
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function new_frame = RemoveBox(frame)

new_frame = [];

% get horizonal boundary
grFrame = double(rgb2gray(frame));
diff1 = mean(abs(grFrame - repmat(mean(grFrame,2), 1, size(grFrame,2))), 2);
st_idx = find (diff1>10);
if isempty(st_idx)
    return;
end;
row_start = st_idx(1);
row_end   = st_idx(length(st_idx));
if (row_end - row_start)/size(frame,1) < 0.5;
    row_start = 1;
    row_end = size(frame,1);
end;

% get vertical boundary
diff2 = mean(abs(grFrame - repmat(mean(grFrame), size(grFrame,1),1)));
st_idx = find(diff2>10);
if isempty(st_idx)
    return;
end;
col_start = st_idx(1);
col_end   = st_idx(length(st_idx));
if (col_end - col_start)/size(frame,2) < 0.5;
    col_start = 1;
    col_end = size(frame,2);
end;

% mainly blank screen
if (col_end - col_start)/size(frame, 2) < 0.25 || (row_end - row_start)/size(frame, 1) < 0.25
    row_start = -1;
    row_end   = -1;
    col_start = -1;
    col_end   = -1;    
    return;
end;

% valid output is expected
new_frame       = frame;
ann_row_end     = row_end;
chk_row_start = floor(row_start + (row_end - row_start)*0.6);
chk_row_end   = row_end;
diff1 = abs(double(frame(chk_row_start:chk_row_end-3, col_start:col_end,1)) - double(frame(chk_row_start+3:chk_row_end, col_start:col_end,1)));
diff2 = abs(double(frame(chk_row_start:chk_row_end-3, col_start:col_end,2)) - double(frame(chk_row_start+3:chk_row_end, col_start:col_end,2)));
diff3 = abs(double(frame(chk_row_start:chk_row_end-3, col_start:col_end,3)) - double(frame(chk_row_start+3:chk_row_end, col_start:col_end,3)));
diff = max(diff1, diff2);
diff = max(diff, diff3);
hor_line_array = find(sum(diff > 50,2)/(col_end - col_start) > 0.70);
if ~isempty(hor_line_array)
    ann_row_end = hor_line_array(1) + chk_row_start;
    if (ann_row_end - row_start)/size(frame,1) > 0.5
        row_end = ann_row_end;
    end;
end;

new_frame = frame(row_start:row_end, col_start:col_end, :);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get the most stable frame among the set of features
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function stableFrameID = GetStableFrame (features)

frsim = zeros(size(features,1),1);
for i=1:size(features,1)
    for j=1:size(features,1)
        if i==j
            continue;
        end;
        frsim(i) = frsim(i) + sum(min(reshape(features(i,:),size(features,2),1), reshape(features(j,:),size(features,2),1)));
    end
end

[v i] = sort(frsim, 'descend');     
stableFrameID = i(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get Color Histogram
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function h = getHist(clip, bins)

clip = double(clip);

if (nargin <= 1)
   bins = 8;
end

z = size(clip,3);
clip2 = zeros(size(clip,1),size(clip,2));

f = 1;
for i = 1:z
   clip2 = clip2 + f*floor(clip(:,:,i)*bins/256);
   f=f*bins;
end

h = hist(reshape(clip2, size(clip2,1)*size(clip2,2), 1), 0:(f-1));
h = h / sum(h);
end
