% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


function config = getConfig

% add all paths
% addpath(genpath(pwd));

config.useGeoFeat = true;
config.useVisualFeat = true;
modelTypeStr = sprintf('Geo=%d_Visual=%d', config.useGeoFeat, config.useVisualFeat);

config.usePrimaryMoodOnly = true;

% text file containing pairs of <annotation-file, video file>
config.annotationListFile = 'annotationList.txt';

config.musicRoot   = '..\..\..\ProgramAudio\DatabaseSrcMp3\Song3730-4458(ISMIRTrain)\';
config.musicDbFile = 'tracklist_new.csv';

% create temporary directory
config.tempDir = '../temp/';
tempDir = config.tempDir;
% if ~exist(tempDir, 'dir')
%     mymkdir(tempDir);
% end;

% temporary data file
config.geoTagMoodInfoFile = [config.tempDir  'annotationInfo.mat'];
config.geoFeatFile        = [tempDir  'geoFeat.mat'];
config.visualFeatFile     = [tempDir  'visualFeat.mat'];
config.trainModelFile     = [tempDir  'svmhmm_' modelTypeStr '.model'];
config.trainDataFile      = [tempDir  'svmhmm.train'];
config.audioFeatFile      = [tempDir  'audioFeat.mat'];
config.audioBucketFile    = [tempDir  'audioHashTable.mat'];
config.logfile            = [tempDir  'logresult_1.txt'];

configStr = 'Current config: ';
if config.useGeoFeat
    configStr = [configStr 'useGeoFeat '];
end;
if config.useVisualFeat
    configStr = [configStr 'useVisualFeat '];
end;
if config.usePrimaryMoodOnly
    configStr = [configStr 'usePrimaryMoodOnly'];
end;
fprintf('%s\n', configStr);
