% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


function [emitWeight, transWeight] = getSvmModelInfo(modelName)
% modelName = 'svm_hmm\BeatlesEllis_BS400_IF_svmhmm.model';

info = dir(modelName);
modelLines = textread(modelName,'%s','delimiter','\n','bufsize',info.bytes);

val = regexp(modelLines{8}, '\d+', 'match');
numWeight = str2num(val{1});

val = regexp(modelLines{9}, '\d+', 'match');
featDim = str2num(val{1});

val = regexp(modelLines{10}, '\d+', 'match');
numClass = str2num(val{1});

val = regexp(modelLines{11}, '\d+', 'match');
hmmTransOrd = str2num(val{1});

val = regexp(modelLines{12}, '\d+', 'match');
hmmEmitOrd = str2num(val{1});

weightAll = zeros(numWeight,2);
words = regexp(modelLines{16}, ' ', 'split');
for k=2:length(words)-1
    val = regexp(words{k}, ':', 'split');
    index = str2num(val{1});
    weight= str2num(val{2});
    weightAll(index,1) = index;
    weightAll(index,2) = weight;
end;

transStart = numClass+1;
transEnd   = transStart+numClass^2-1;
transWeight= weightAll(transStart:transEnd,2);
transWeight= reshape(transWeight, numClass, numClass);
transWeight= transWeight';

emitStart = numClass^2+numClass+featDim+2;
emitEnd   = emitStart + featDim*numClass -1;
emitWeight= weightAll(emitStart:emitEnd,2);
emitWeight= reshape(emitWeight, featDim, numClass);
emitWeight= emitWeight';
